import sys
import datetime


from System.Net.Sockets import TcpClient
from System.Text import Encoding
from System.Net import WebRequest
from System.IO import StreamReader

 
startRunning=False



##TokenData (Developer/Integrator Key)
AccessToken = "API TOKEN"
##URI Endpoint
uri = "https://utm.agi.com/api/flights/pathSimple"

##Needed Parameters......
FlightName = 'FLIGHTNAME' 
WaypointFilePath = "PATH TO Mission Planner WAYPOINT FILE"
startTimeZulu = 'DATE/TIME ISO FORMAT' ##Time format: 2017-03-12T12:15:30Z
avgVelocity = 5 ##Enter in meters/second



LatList=[]
LonList=[]
AltList=[]



print 'Reading Waypoints and creating UTM Flight'


with open(WaypointFilePath, 'r') as File:
	for line in File:
		if line.startswith('QGC'):
			pass
		else:
			parseLine = line.split()
			if parseLine[3] == '16' and parseLine[2] == '3':
				lat = parseLine[8]
				LatList.append(lat)
				lon = parseLine[9]
				LonList.append(lon)
				alt = parseLine[10]
				AltList.append(alt)
				##print(lat + " " + lon + " " + alt)				

				
 

def UTMFlightPlanCreate(uri, inputData, AccessToken):
    request = WebRequest.Create(uri)
    request.ContentType = "application/json"
    request.Method = "POST"
    request.Headers.Add("Authorization", "Bearer " + AccessToken);
    bytes = Encoding.ASCII.GetBytes(inputData)
    request.ContentLength = bytes.Length
    reqStream = request.GetRequestStream()
    reqStream.Write(bytes, 0, bytes.Length)
    reqStream.Close()

    response = request.GetResponse()
    result = StreamReader(response.GetResponseStream()).ReadToEnd()
    return result


inputData= '{"name": "' + FlightName + '",' + '"description": "This is my flight description","altitudeReference":"AGL","waypoints":['
for i in xrange(len(LatList)):
	inputData = inputData + '{"longitude":' + str(LonList[i]) + ',"latitude":' + str(LatList[i]) + ',"altitude":' + str(AltList[i]) + '},'
	
inputData = inputData[:-1] + '],"startTime":"' + startTimeZulu + '","speed":' + str(avgVelocity) + '}'

response = UTMFlightPlanCreate(uri, inputData, AccessToken)
print response

	
    

    

    
