import sys
import datetime

from System.Net.Sockets import TcpClient
from System.Text import Encoding
from System.Net import WebRequest
from System.IO import StreamReader

 
startRunning=True


##GUFI (Unique ID for Flight in UTM)
GUFI = "GUFI GOES HERE"
##TokenData (Developer/Integrator Key)
AccessToken = "TOKEN GOES HERE"



print 'Starting Script'

def UTMRealTimeUpdate(uri, inputData, AccessToken):
    request = WebRequest.Create(uri)
    request.ContentType = "application/json"
    request.Method = "POST"
    request.Headers.Add("Authorization", "Bearer " + AccessToken);
    bytes = Encoding.ASCII.GetBytes(inputData)
    request.ContentLength = bytes.Length
    reqStream = request.GetRequestStream()
    reqStream.Write(bytes, 0, bytes.Length)
    reqStream.Close()

    response = request.GetResponse()
    result = StreamReader(response.GetResponseStream()).ReadToEnd()
    return result  

    
while (startRunning):
    ##Get various altitude measures from Mission Planner.  Use as necessary to send correct/expected altitude ref to UTM 
	curLat = str(cs.lat)
	curLon = str(cs.lng)
	curAlt = float(cs.alt)
	homeAlt = float(cs.HomeAlt)
	AltASL = float(cs.altasl)
	pressure = float(cs.press_abs)
	AltAdjust = -34.0 ##Use this to adjust the altitude if needed.  Typically use the GEOID value to convert Mission Planner's ASL altitude to WGS84 altitudes
	finalAlt = str(AltASL + AltAdjust)
	curTime = datetime.datetime.utcnow().isoformat()
	curTimeZulu = curTime + 'Z'
    
	##Example of using pressure altitude/conversion
	pressAlt = str(((1013.25/pressure)**(1/5.257)-1)*(15+273.15)/.0065)
	
	
	print 'Current Lat:' + curLat + ' Current Lon:' + curLon + ' Current Alt:' + finalAlt + ' Time Zulu:' + curTimeZulu
    
	
	##Make REST call to UTM API and push telemetry position data
	uri = "https://utm.agi.com/api/flights/telemetry/append/" + GUFI
    
    ## Formatted input data the REST API expects
	inputData= '{"eventType": "REALTIME_WAYPOINT","timestamp": "' + curTimeZulu + '","referenceLocation":{"longitude": ' + curLon + ',"latitude": ' + curLat + ',"altitude": ' + finalAlt+ '},"data": "any extra data"}'

	response = UTMRealTimeUpdate(uri, inputData, AccessToken)
	print response
    
	## Loop every 600 milliseconds for example
	Script.Sleep(600)
    

    
